/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.HorarepeticaoRecord;

import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Horarepeticao extends TableImpl<HorarepeticaoRecord> {

    private static final long serialVersionUID = 469685968;

    /**
     * The reference instance of <code>public.horarepeticao</code>
     */
    public static final Horarepeticao HORAREPETICAO = new Horarepeticao();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<HorarepeticaoRecord> getRecordType() {
        return HorarepeticaoRecord.class;
    }

    /**
     * The column <code>public.horarepeticao.horid</code>.
     */
    public final TableField<HorarepeticaoRecord, Integer> HORID = createField("horid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('horarepeticao_horid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.horarepeticao.horhora</code>.
     */
    public final TableField<HorarepeticaoRecord, String> HORHORA = createField("horhora", org.jooq.impl.SQLDataType.VARCHAR(5), this, "");

    /**
     * The column <code>public.horarepeticao.hordiainicial</code>.
     */
    public final TableField<HorarepeticaoRecord, Date> HORDIAINICIAL = createField("hordiainicial", org.jooq.impl.SQLDataType.DATE, this, "");

    /**
     * The column <code>public.horarepeticao.horrepetiracada</code>.
     */
    public final TableField<HorarepeticaoRecord, Integer> HORREPETIRACADA = createField("horrepetiracada", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.horarepeticao.hortiporepeticao</code>.
     */
    public final TableField<HorarepeticaoRecord, String> HORTIPOREPETICAO = createField("hortiporepeticao", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * Create a <code>public.horarepeticao</code> table reference
     */
    public Horarepeticao() {
        this(DSL.name("horarepeticao"), null);
    }

    /**
     * Create an aliased <code>public.horarepeticao</code> table reference
     */
    public Horarepeticao(String alias) {
        this(DSL.name(alias), HORAREPETICAO);
    }

    /**
     * Create an aliased <code>public.horarepeticao</code> table reference
     */
    public Horarepeticao(Name alias) {
        this(alias, HORAREPETICAO);
    }

    private Horarepeticao(Name alias, Table<HorarepeticaoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Horarepeticao(Name alias, Table<HorarepeticaoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.HORAREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<HorarepeticaoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_HORAREPETICAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<HorarepeticaoRecord> getPrimaryKey() {
        return Keys.HORAREPETICAO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<HorarepeticaoRecord>> getKeys() {
        return Arrays.<UniqueKey<HorarepeticaoRecord>>asList(Keys.HORAREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Horarepeticao as(String alias) {
        return new Horarepeticao(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Horarepeticao as(Name alias) {
        return new Horarepeticao(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Horarepeticao rename(String name) {
        return new Horarepeticao(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Horarepeticao rename(Name name) {
        return new Horarepeticao(name, null);
    }
}
